/* module-VmeSmp.hh */
/* Created by Enomoto Sanshiro on 27 July 1999. */
/* Last updated by Enomoto Sanshiro on 4 November 2001. */


// ******************************************** //
// * THIS CODE IS NOT MAINTAINED. DO NOT USE. * //
// ******************************************** //


#ifndef __module_VmeSmp_hh__
#define __module_VmeSmp_hh__


#include "RoomDefs.hh"
#include "RoomModule.hh"
#include "RoomTkoAccess.hh"


class TVmeMisc_VmeSmp: public TRoomVmeModule {
  public:    
    TVmeMisc_VmeSmp(void);
    virtual ~TVmeMisc_VmeSmp();
    virtual TRoomVmeModule* Clone(void);
    virtual int Clear(int Address = -1) throw(THardwareException);
    virtual int NextDataBlockSize(int Address = -1) throw(THardwareException);
    virtual int BlockRead(int Address, void *Data, int MaxSize) throw(THardwareException);
    virtual int EnableInterrupt(int SignalId = 0) throw(THardwareException);
    virtual int DisableInterrupt(void) throw(THardwareException);
    virtual int ClearInterrupt(void) throw(THardwareException);
  public:
    virtual void EnableServiceRequest(void) throw(THardwareException);
    virtual void DisableServiceRequest(void) throw(THardwareException);
    virtual void ClearServiceRequest(void) throw(THardwareException);
    virtual bool IsRequestingService(void) throw(THardwareException);
  protected:
    enum TVmeSmpParameters {
	MapSize_VmeSmp = 0x180020,
	TransferMode_VmeSmp = VmeTransferMode_A32D32,
	BufferSize = 0x00100000,
	_NumberOfParameters
    };
    enum TVmeSmpRegisters {
	regCommand = 0x180000,
	regStatus = 0x180000,
	regSerialNumberCounterControl = 0x180004,
	regSerialNumberCounter = 0x180008,
	regDataSize = 0x18000c,
	regEventNumber = 0x180010,
	regBufferControl = 0x180014,
	regSwitchCondition = 0x180018,
	regInterruptControl = 0x18001c,
	regInterruptVector = 0x180020,
	_NumberOfRegisters
    };
    enum TVmeSmpControlBits {
	bitBufferOverFlow = 0x80000000,
	_NumberOfControlBits
    };
    enum TVmeSmpInterruptControlBits {
	bitInterruptFlag = 0x80,
	bitInterruptFlagAutoClear = 0x40,
	bitInterruptEnable = 0x20,
	bitInterruptAutoClear = 0x10,
	_NumberOfInterruptBits
    };
};


class TTkoController_VmeSmp: public TRoomTkoController, public TVmeMisc_VmeSmp {
  public:
    TTkoController_VmeSmp(void);
    virtual ~TTkoController_VmeSmp();
    virtual int TkoAction(int ModuleAddress, int Address, int Function, int &Data, int &Q) throw(THardwareException);
};


#endif
