#! /usr/bin/perl
# makehist.pl
# Created by Sanshiro Enomoto on 30 June 2000.
# Last updated by Sanshiro Enomoto on 21 February 2008.


($nbins, $min, $max) = @ARGV;
($max != 0) or die "Usage: makehist NBINS MIN MAX\n";

$range = $max - $min;
$step = $range / $nbins;

while (<STDIN>) {
    if (/(^\s*\#|^\s$)/) {
	print;
	next;
    }

    chop($_);
    @record = split(/[,\s]\s*/, $_);

    for ($field_index = 1; $field_index < @record; $field_index++) {
        $value = $record[$field_index];
	if (($value < $min) or ($value >= $max)) {
	    next;
	}

        $bin = int (($value - $min) / $range * $nbins);
	$counts[$field_index][$bin] += 1;
    }
}

for ($bin = 0; $bin < $nbins; $bin++) {
    $bin_value = $min + $bin * $step;
    print "$bin_value    ";

    for ($field_index = 0; $field_index < @record; $field_index++) {
        $count = 0 + $counts[$field_index][$bin];
	print "$count    ";
    }
    print "\n";
}
